$input a_position, a_texcoord0, a_normal, a_tangent
$output v_position, v_texcoord0, v_tangentBasis

#include "common.sh"

uniform mat3 u_modelNormal;

void main() {
    // Calculate world space coordinates.
    v_position = vec3(u_model[0] * vec4(a_position, 1.0));

    // Pass UV texture coordinates.
    v_texcoord0 = a_texcoord0;

    // Calculate TBN matrix.
    vec3 N = normalize(a_normal);
    vec3 T = normalize(a_tangent.xyz);
    vec3 B = normalize(cross(N, T) * a_tangent.w);
    v_tangentBasis = u_modelNormal * mat3(T, B, N);

    // Calculate clip space coordinates.
    gl_Position = u_modelViewProj * vec4(a_position, 1.0);
}
